# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Member(pulumi.CustomResource):
    address: pulumi.Output[str]
    """
    The IP address of the member to receive traffic from
    the load balancer. Changing this creates a new member.
    """
    admin_state_up: pulumi.Output[bool]
    """
    The administrative state of the member.
    A valid value is true (UP) or false (DOWN).
    """
    name: pulumi.Output[str]
    """
    Human-readable name for the member.
    """
    pool_id: pulumi.Output[str]
    """
    The id of the pool that this member will be
    assigned to.
    """
    protocol_port: pulumi.Output[int]
    """
    The port on which to listen for client traffic.
    Changing this creates a new member.
    """
    region: pulumi.Output[str]
    """
    The region in which to obtain the V2 Networking client.
    A Networking client is needed to create an . If omitted, the
    `region` argument of the provider is used. Changing this creates a new
    member.
    """
    subnet_id: pulumi.Output[str]
    """
    The subnet in which to access the member
    """
    tenant_id: pulumi.Output[str]
    """
    Required for admins. The UUID of the tenant who owns
    the member.  Only administrative users can specify a tenant UUID
    other than their own. Changing this creates a new member.
    """
    weight: pulumi.Output[int]
    """
    A positive integer value that indicates the relative
    portion of traffic that this member should receive from the pool. For
    example, a member with a weight of 10 receives five times as much traffic
    as a member with a weight of 2.
    """
    def __init__(__self__, __name__, __opts__=None, address=None, admin_state_up=None, name=None, pool_id=None, protocol_port=None, region=None, subnet_id=None, tenant_id=None, weight=None):
        """
        Manages a V2 member resource within OpenStack.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] address: The IP address of the member to receive traffic from
               the load balancer. Changing this creates a new member.
        :param pulumi.Input[bool] admin_state_up: The administrative state of the member.
               A valid value is true (UP) or false (DOWN).
        :param pulumi.Input[str] name: Human-readable name for the member.
        :param pulumi.Input[str] pool_id: The id of the pool that this member will be
               assigned to.
        :param pulumi.Input[int] protocol_port: The port on which to listen for client traffic.
               Changing this creates a new member.
        :param pulumi.Input[str] region: The region in which to obtain the V2 Networking client.
               A Networking client is needed to create an . If omitted, the
               `region` argument of the provider is used. Changing this creates a new
               member.
        :param pulumi.Input[str] subnet_id: The subnet in which to access the member
        :param pulumi.Input[str] tenant_id: Required for admins. The UUID of the tenant who owns
               the member.  Only administrative users can specify a tenant UUID
               other than their own. Changing this creates a new member.
        :param pulumi.Input[int] weight: A positive integer value that indicates the relative
               portion of traffic that this member should receive from the pool. For
               example, a member with a weight of 10 receives five times as much traffic
               as a member with a weight of 2.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not address:
            raise TypeError('Missing required property address')
        __props__['address'] = address

        __props__['admin_state_up'] = admin_state_up

        __props__['name'] = name

        if not pool_id:
            raise TypeError('Missing required property pool_id')
        __props__['pool_id'] = pool_id

        if not protocol_port:
            raise TypeError('Missing required property protocol_port')
        __props__['protocol_port'] = protocol_port

        __props__['region'] = region

        __props__['subnet_id'] = subnet_id

        __props__['tenant_id'] = tenant_id

        __props__['weight'] = weight

        super(Member, __self__).__init__(
            'openstack:loadbalancer/member:Member',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

